require 'singleton'

module MirrorMirror::Transformation
  class Base
    include Singleton

    def self.inherited(subclass)
      super
      @subclasses ||= []
      @subclasses << subclass
    end

    def self.instances
      @subclasses.map {|c| c.instance }
    end
  end
end

