module MirrorMirror::Transformation
  class BorderRadius < PropertyTransformation
    def transform_value?(name)
      name == "border-radius"
    end

    def transform_value(name, value)
      values = value.split(/ +/)
      h_radii = []
      v_radii = []
      has_separator = false
      values.each do |v|
        if v == "/"
          has_separator = true
          next
        end
        if has_separator
          v_radii << v
        else
          h_radii << v
        end
      end
      flip_corners!(h_radii)
      flip_corners!(v_radii)
      values[0...h_radii.size] = h_radii
      if v_radii.any?
        values[(h_radii.size+1)..(h_radii.size+v_radii.size)] = v_radii
      end
      values.join(" ")
    end

    def flip_corners!(list)
      list[0], list[1] = list[1], list[0] if list.size > 1
      list[2], list[3] = list[3], list[2] if list.size > 3
      nil
    end
  end
end

