module MirrorMirror::Transformation
  class BoxShadow < PropertyTransformation
    def transform_expression?(name)
      name == "box-shadow"
    end

    NEGATIVE_ONE = Sass::Script::Number.new(-1)

    def transform_expression(name, expression)
      for_each_value(expression) do |e|
        case e
        when Sass::Script::List
          if e.value[0].is_a?(Sass::Script::Number)
            e.value[0] = flip_it(e.value[0])
          end
        when Sass::Script::Number
          e = flip_it(e)
        end
        e
      end
    end

    def flip_it(expression)
      opts(expression.options) do
        expression.times(NEGATIVE_ONE)
      end
    end
  end
end



