require 'set'
module MirrorMirror::Transformation
  class QuadShorthand < PropertyTransformation
    SHORTHAND_PROPERTIES = Set[
      'border-color',
      'border-width',
      'border-style',
      'margin',
      'outline',
      'padding'
    ]
    def transform_expression?(name)
      SHORTHAND_PROPERTIES.include?(name)
    end

    def transform_expression(name, expression)
      if expression.is_a?(Sass::Script::List) &&
         expression.separator == :space &&
         expression.value.size == 4
        expression.value[1], expression.value[3] = expression.value[3], expression.value[1]
      end
      expression
    end
  end
end
